#include <errno.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include "lexicon.h"
// #include "nr.h"  taken out by GW
#define GCC   /* comment out for Windows/USPARC/MAC compiling */
/* #define WINDOWS */ /* comment out for gcc/USPARC/MAC compiling */
/* #define USPARC  comment out for Windows/GCC/MAC compiling */
/* #define MAC  comment out for Windows/GCC/USPARC compiling */
#ifdef GCC /* headers for gcc only */
/* #include<c.h> */
#endif
#ifdef USPARC /* headers for usparc only */
#include <sys/ddi.h>
#endif
/* globally defined functions */

/* Calculate the probability of observing a particular genotype, given the allele counts of a sample */

double calcProb (int geno[2],int *absFreq, int npopinds, int nalleles);

/* Calculate the probability of observing a particular genotype, given the allele counts of two samples.  
The genotype is assumed to include one allele from one population, and one allele from the other. */

double calcProbMix (int geno[2], int *absFreqG, int *absFreqGG, int npopindsG, int npopindsGG, int nalleles);

/* Generate a random genotype given the allele counts of a sample */

int getRandomGenotype(int genotype[2],int *absFreq, int nalleles,int npopinds);

/* Generate a random genotype given the allele counts of two populations.  One allele is chosen from one sample, while the other is chosen from the second population */ 

void getRandomGenotypeMix(int genotype[2],int *absFreqG,int *absFreqGG, int nalleles, int mixGen,int npopindsG,int npopindsGG);

/* compare two integers and return largest */

int maxcomp(int i,int j);
